;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:        E.Bonser
;
; Script Function:
;To allow a teacher/carer/parent to modify the functions of a mouse/interactive whiteboard to make it more accessible to a student with special needs.

#InstallMouseHook ;These hooks might allow this program to work with a greater variety of software such as flash
#InstallKeybdHook
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
CoordMode, Mouse,
SetWinDelay, 0

;Set the mouse boundaries as full screen initially so the mouse will work within the gui straight away
Cornerx1 = 3
Cornery1 = 3
Cornerx2 := % A_ScreenWidth - 4 ;Need the minus 4 so the green boundary is visible
Cornery2 := % A_ScreenHeight - 4
started = 0 ; At toggle that turns to 1 after the "Begin" button is pressed:
;Set the Buttons as themselves so they can be used in the gui until the gui is submitted and the hotkeys changed
LButtonChoice = LButton
MButtonChoice = MButton
RButtonChoice = RButton
;Error Logs for use as assement and reporting on skill development
LButtonErrorLog = 0
MButtonErrorLog = 0
RButtonErrorLog = 0
ScrollWheelErrorLog = 0
;Cornerval is the current corner used when choosing mouse boundaries - when it is 3 it means that the 2 diagonal corners have been found
cornerval = 1
BoundaryToggle = 0 ;Toggles to 1 once the 'Set Mouse Limits' button is pressed and back to 0 after 2 LButton clicks
MouseCursor = Blank
Dragenable = 1
SelItem1 = 100
LoadSetting = Blank
DropList1 = 
DropList2 =
settimer, refreshcursor, 40

Gui, 1:Add, Tab2,w190 h345, Step1|Step2|Step3|About
Gui, 1:Tab, Step1
Gui, 1:Add, Picture, x30 y50 w150 h-1, %A_Scriptdir%\Data\MouseSymbol.jpg
Gui, 1:Add, DropDownList, x2 y50 w70 vLButtonChoice, LButton||MButton|RButton|Nothing
Gui, 1:Add, DropDownList, x60 y30 w70 vMButtonChoice, LButton|MButton|RButton|Nothing||
Gui, 1:Add, DropDownList, x120 y50 w70 vRButtonChoice, LButton|MButton|RButton|Nothing||
;Gui, 1:Add, ListView, x25 y240 w160 h100 gLoadPre-madeSettings sort -multi -LV0x10 vLoadSetting, Click to Load Settings
;Loop, %A_ScriptDir%\Data\Saved Settings\*.*
;{
;	Gui, 1:ListView, LoadSetting
;	LV_Add(select, A_LoopFileName)
;}
Loop, %A_ScriptDir%\Data\Saved Settings\*.*
{
	File = %A_LoopFileName%
	StringReplace, File, File,.gif,,All
	Droplist2 = %File%|%DropList2%
}
;StringTrimRight,DropList2,DropList2,1
Gui, Add, DropDownList, x25 y260 w160 gLoadPre-madeSettings vSettingsFile, %DropList2%Or Click to Load Settings||

Gui, 1:Tab, Step2
Gui, 1:Add, Button, x15 y30, Set Mouse Limits
Gui, 1:Add, Text,x15 y55,To set mouse boundaries Left Click `nthe top left and bottom right`n corners of the workarea.`n Default = fullscreen boundary`nTo resize the limits hold r and drag top`nleft to bottom right corner of workarea.
gui, font, w700,
Gui, 1:Add, Text,x15 y135,Extra Mouse Functions:
gui, font, 
Gui, 1:Add, Checkbox, x15 y155 vScrollupEnable, Enable Scroll Wheel Up
Gui, 1:Add, Checkbox, x15 y170 vScrolldownEnable, Enable Scroll Wheel Down
Gui, Add, Radio, x20 y190 vSMARTenable, SMARTboard Painting?
Gui, Add, Radio, x20 y205 checked vDragEnable, Enable mouse click hold?
Gui, Add, Radio, x20 y220 vJustClick, Just Click?`n (SMARTboard AND Mouse)

Gui, 1:Add, Text,x20 y275,Mouse Movement Speed:
Gui, 1:Add, Edit,x140 y275 w40
Gui, 1:Add, UpDown, x150 y275 vMousespeed Range0-10, 6

Gui, 1:Tab, Step3
Gui, 1:Add, Text, x20 y55, Choose an image file. Gif images with`n transparency are best.
;Gui, 1:Add, ListView, x20 y90 w160 h90 gClickonMouseCursor sort -multi -LV0x10 altsubmit vMouseCursor, Cursor Images
Loop, %A_ScriptDir%\Data\Cursors\*.*
{
	File = %A_LoopFileName%
	StringReplace, File, File,.gif,,All
	Droplist1 = %File%|%DropList1%
}
;StringTrimRight,DropList1,DropList1,1
Gui, Add, DropDownList, x20 y90 w160 vMouseCursor, %DropList1%Click to Choose Cursor||

;Loop, %A_ScriptDir%\Data\Cursors\*.*
;{
;	Gui, 1:ListView, MouseCursor
;	LV_Add(select, A_LoopFileName)
;}

Gui, 1:Add, Button, x60 y190 default, Save Settings
Gui, 1:Add, Button, x75 y255 default, BEGIN

Gui, 1:Tab, About
Gui, 1:Add, Text, x20 y30, Copyright 2009 Evan Bonser,`n   evandevon@hotmail.com
Gui, 1:Add, Button, x20 y70, License

		Gui, 2: Font, s40 cred bold, Times New Roman
		Gui, 2: Add, Text, cred x40 y5,ATTENTION!
		Gui, 2: Font, s20 , Times New Roman
		Gui, 2: Add, Text, x20 y60, Mouse movement is locked. Press and`nhold the "control" key to allow movemet
		

Gui, 1:show, w205 h300 x100 y200, MouseTrainer 0.6
/* 
ToolTip,.                                 MouseTrainer 0.6 By E.Bonser`n This program is written using the AHK scripting language and is released`n under the GPL2.0. It allows you to modify the mouse's clicks to suit the`n preference and ability of the user.`n`n                                          INSTRUCTIONS:`nStep1: Choose functions from the drop down lists (or click 'Load Settings')`nStep2.Set the mouse work area and choose functions.`nStep3.Choose an image for a mouse cursor and save settings.`n                                Click 'Begin'!`n`nUSAGE-Press 'control' and 'left click' together to click outside workarea.`n           -TO QUIT PRESS 'ALT' AND 'Q' TOGETHER`nBUGS-This program might not work with some games.`n         -Mouse mightn't click when loading/saving settings (fix = hold control)`n`n, 215,-10,


    SKILL LEVELS:`n1:All set to 'nothing' (movement only).`n2:All set to 'LButton' (Enable 'Drag' for painting).`n3:Lbutton set to 'Lbutton'. Others set to 'nothing'. (Finger Control)`n4:LButton = 'LButton'. Mbutton ='nothing'. Rbutton = 'Rbutton'.`n5:LButton = 'LButton'. MButton = 'MButton'. Rbutton = 'Rbutton'.`n6:Scrolls enabled`n7:No longer need this program.
*/ 
Return
;The mouse cursor image is preferably a .gif file with transparency but will also work with other file formats and sets pure black to transparent
ButtonLicense:
{
	Run, Data\License.txt
	return
}

ClickonMouseCursor:
{
	Gui, 1:Default
	Gui, 1:ListView, Cursor Images
	SelItem1 := LV_GetNext()
	LV_GetText(MouseCursor, SelItem1, 1)
	return
}

ButtonBegin:
{
	
	DllCall("SystemParametersInfo", UInt, 0x70, UInt, 0, UIntP, Mouse_Speed_Orig, UInt, 0) ;Reads the original mouse speed
	borderheightstretch := % Cornery2 - Cornery1
	borderwidthstretch := % Cornerx2 - Cornerx1

	gui, submit, hide
	
	clipboard = %A_ScriptDir%\Data\Cursors\%MouseCursor%.gif
	run, %A_ScriptDir%\Data\MouseCursorCreator.exe
	ToolTip,
		
	CoordMode, Mouse, screen
	MouseGetPos, currentxPosition, CurrentyPosition
	SplashImage, 3:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H3 W%borderwidthstretch%,,,TopLimit
	SplashImage, 4:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H%borderheightstretch% W2,,,LeftLimit
	SplashImage, 5:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx2% y%Cornery1% H%borderheightstretch% W3,,,RightLimit
	SplashImage, 6:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery2% H3 W%borderwidthstretch%,,,DownLimit
	DllCall("SystemParametersInfo", UInt, 0x71, UInt, 0, UInt, Mousespeed, UInt, 0) ;Writes the desired mousespeed
	
started = 1
	If (MouseSpeed = 0)
	{
		msgbox,,,You have set the mouse speed to 0.`nPress and hold "Control" to move the mouse.`nPress escape to return to setup,8
		return
	}
	msgbox,,,Press escape to return to setup,4
Return
}


ButtonSetMouseLimits:
{	
	Cornerval = 1
	SplashImage, 1:Off ;Turn off all splashimages if want to change the boundaries if have already set them
	SplashImage, 2:Off
	SplashImage, 3:Off
	SplashImage, 4:Off
	SplashImage, 5:Off
	SplashImage, 6:Off
	
	SplashImage, 1:%A_ScriptDir%\Data\MouseBlocker - Target.gif, B x%xpos% y%pos%,,,targetcorner
	WinSet, TransColor, black, targetcorner
	WinSet, AlwaysonTop, On , targetcorner
	
	BoundaryBoxxpos := % A_ScreenWidth/2 - 100
	BoundaryBoxypos := % A_ScreenHeight/2 - 100
	SplashImage, 2:%A_ScriptDir%\Data\Boundary Box Instructions.jpg, B1 x%BoundaryBoxxpos% y%BoundaryBoxypos%,,,Boundary Box Instructions
	
	BoundaryToggle = 1
	return
}
;###############################Saving and loading the configuration to an .ini file
ButtonSaveSettings:
{
	FileSelectFile, savedsettings ,S, %A_ScriptDir%\Data\Saved Settings\User, Name and Save your settings,
	If ErrorLevel
		Return
	gui, submit, nohide
	FileAppend,%LButtonChoice%`n%MButtonChoice%`n%RButtonChoice%`n%DragEnable%`n%ScrollupEnable%`n%ScrolldownEnable%`n%MouseCursor%`n%Cornerx1%`n%Cornery1%`n%Cornerx2%`n%Cornery2%`n%Mousespeed%`n%SMARTenable%,%savedsettings%.user
	cornerval = 4 ; to stop the stuff in the lbutton hotkey trying to draw the boundaries again
	
return
}

LoadPre-madeSettings: ;########Find file, read loop it then start the program use
{
gui, submit, hide
Gui, 1:Default

	winhide, MouseTrainer 0.6
	Tooltip,

    FileReadLine, LButtonChoice, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 1
	FileReadLine, MButtonChoice, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 2
	FileReadLine, RButtonChoice, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 3
	FileReadLine, DragEnable, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 4
	FileReadLine, ScrollupEnable, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 5
	FileReadLine, ScrolldownEnable, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 6
	FileReadLine, MouseCursor, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 7
	FileReadLine, Cornerx1, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 8
	FileReadLine, Cornery1, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 9
	FileReadLine, Cornerx2, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 10
	FileReadLine, Cornery2, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 11
	FileReadLine, Mousespeed, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 12
	FileReadLine, SMARTenable, %A_ScriptDir%\Data\Saved Settings\%settingsfile%, 13

	CoordMode, Mouse, screen
	MouseGetPos, currentxPosition, CurrentyPosition
		borderheightstretch := % Cornery2 - Cornery1
		borderwidthstretch := % Cornerx2 - Cornerx1
	
		SplashImage, 3:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H3 W%borderwidthstretch%,,,TopLimit
		SplashImage, 4:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H%borderheightstretch% W2,,,LeftLimit
		SplashImage, 6:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery2% H3 W%borderwidthstretch%,,,DownLimit
		SplashImage, 5:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx2% y%Cornery1% H%borderheightstretch% W3,,,RightLimit
	
		clipboard = %A_ScriptDir%\Data\Cursors\%MouseCursor%.gif

		run, %A_ScriptDir%\Data\MouseCursorCreator.exe
		DllCall("SystemParametersInfo", UInt, 0x71, UInt, 0, UInt, Mousespeed, UInt, 0)

started = 1
If (MouseSpeed = 0)
	{
		msgbox,,,You have set the mouse speed to 0.`nPress and hold "Control" to move the mouse.`nPress escape to return to setup,8
		return
	}
msgbox,,,Press escape to return to setup,4
return
}


;##############################This is called continually to check the mouseposition for use in setting the boundaries originally
;##############################It is also used to block the mousemovement if mouse speed is set to 0
;#################Should remove the mousegetpos from each button hotkey to optimise the process
refreshcursor:
{
	GetKeyState, CtrlisDown, ctrl,  ;This is checking to see if the option to disable mouse movement is checked and to allow movement if it control is pressed
		if(ctrlisdown ="D")
			Blockinput, MouseMoveOff
		If(ctrlisdown ="U" AND Mousespeed = 0)
			Blockinput, Mousemove
		
	MouseGetPos, xPosition, yPosition

	if (cornerval < 3) ;If it is less than 3 then the user is still in setup 
	{
    xpos = % xposition - 123
	ypos = % yposition - 123
	WinMove, targetcorner, , %xpos%, %ypos%
	}
    Else
	{
	SplashImage, 1: Off
	;settimer, refreshcursor, off
	}	
return
}


;#################################################################################################################################################################
Lbutton::
{	
	CoordMode, Mouse, screen
	MouseGetPos, CurrentxPosition, CurrentyPosition
;=======================================================================================
;++++++++++++++++++++++++SMARTBOARD PAINTING	
;=======================================================================================
	;This part checks if the SMARTboard painting setting is selected and if the mouse is within the boundaries
	if(SMARTenable = 1 AND CurrentxPosition > Cornerx1 AND CurrentxPosition < Cornerx2 AND CurrentyPosition > Cornery1 AND CurrentyPosition < Cornery2)
	{
		oldmousex = 0 ;initialises the variables
		oldmousey = 0
		send, {lbutton down} 
		
		loop ;Works out when you've taken your finger off the interactive whiteboards - Used as a general Interactive Whiteboard PAINTING script:Not always recommended
		{
			sleep, 150
			MouseGetPos, newmouseX, newmouseY,
			if(newmousex = oldmousex AND newmousey = oldmousey)
			{
				send, {Lbutton UP}
				break
			}
		oldmousex := newmousex
		oldmousey := newmousey
		}
	return
	}
;=======================================================================================
;+++++++++++++++++++++++++Boundary Setup Section
;=======================================================================================
	;This Part is used during the setup process and checks to see if you have pressed the "Set Mouse Limits" button and currently choosing the corners of your boundary	
;msgbox, %boundarytoggle%, %cornerval%
;tooltip,%boundarytoggle%_%cornerval%
if(BoundaryToggle = 1 AND cornerval < 4)	
	{		
			WinSet, Top, , targetcorner	
			Keywait, Lbutton, ;upon clicking the cordinates of the mouse (collected earlier in Lbutton hotkey)
			Cornerx%cornerval% = %xposition%
			Cornery%cornerval% = %yposition%
			cornerval = % cornerval + 1  ;Because boundary toggle needs to be on cornerval never goes beyond 3

			If(Cornerval = 3) ;On the second corner mouseclick of the setup stage draw the boundary box
			{
				;tooltip, cornerval = 3
				borderheightstretch := % Cornery2 - Cornery1
				borderwidthstretch := % Cornerx2 - Cornerx1
	
				SplashImage, 3:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H3 W%borderwidthstretch%,,,TopLimit
				SplashImage, 4:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery1% H%borderheightstretch% W2,,,LeftLimit
				SplashImage, 6:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx1% y%Cornery2% H3 W%borderwidthstretch%,,,DownLimit
				SplashImage, 5:%A_ScriptDir%\Data\MouseBlocker - Green Square.gif, B x%Cornerx2% y%Cornery1% H%borderheightstretch% W3,,,RightLimit
				winclose, Boundary Box Instructions
				Winshow, MouseTrainer 0.6
				WinSet, Top, , MouseTrainer 0.6
				BoundaryToggle = 0
			}
			return
	}
		
;=======================================================================================
;+++++++++++++++++++++++++Mouse Hotkey Section
;=======================================================================================
	IfInString, LButtonChoice, nothing 
	{
		++LButtonErrorLog
		return
	}
	Else
	{
		CoordMode, Mouse, screen
				If(CurrentxPosition > Cornerx1 AND CurrentxPosition < Cornerx2 AND CurrentyPosition > Cornery1 AND CurrentyPosition < Cornery2)
				{			
						If(Dragenable = 1 AND started = 1) ;Allows the user to hold down the LButton and drag stuff round (good for painting - But not on SMARTboard[buggy])
						{
							sendinput,{%lbuttonchoice% down}
							KeyWait, Lbutton,
							Sendinput,{%lbuttonchoice% up}
						}
						Else
						{			
							;	Sendinput,{%LButtonChoice% down}
							;	KeyWait, Lbutton
							;	Sendinput,{%LButtonChoice% up}
								click
							
						}
				}
						;tooltip, hotkey was sent
	}

Return	
}


;#############################################################################
Mbutton::
{
	IfInString, MButtonChoice, nothing
	{
		++MButtonErrorLog
		return
	}
	
		CoordMode, Mouse, screen
		MouseGetPos, currentxPosition, CurrentyPosition
		If(CurrentxPosition > Cornerx1 AND CurrentxPosition < Cornerx2 AND CurrentyPosition > Cornery1 AND CurrentyPosition < Cornery2)
		{
			IfInString, MButtonChoice, LButton	
			{
				
				If(Dragenable = 1)
				{
					send,{lbutton down}
					KeyWait, Mbutton
					Send,{Lbutton up}
					
				}
				Else
				Send, {LButton down}{LButton up}
				
			}
			Else
			{
				Send, {%MButtonChoice% down}{%MButtonChoice% up}	
			}
		}

Return	
}

Rbutton::
{
	IfInString, RButtonChoice, nothing
	{
		++RButtonErrorLog
		return
	}
	Else
	{
		CoordMode, Mouse, screen
		MouseGetPos, currentxPosition, CurrentyPosition
		If(CurrentxPosition > Cornerx1 AND CurrentxPosition < Cornerx2 AND CurrentyPosition > Cornery1 AND CurrentyPosition < Cornery2)
		{
			IfInString, RButtonChoice, LButton	
			{
				If(Dragenable = 1)
				{
					Send,{lbutton down}
					KeyWait, Rbutton
					Send,{Lbutton up}
				}
				Else
				{
					Send,{%RButtonChoice% down}{%RButtonChoice% up}	
				}
			}
		}
	}
Return	
}
r::send, r
return

;###################################################################Resize hotkey for the mouse boundaries
r & lbutton::
{
	;grab x1,y1
	CoordMode, Mouse, screen
	MouseGetPos, Resizex1, Resizey1
	;start looping a redraw of the limits
	loop
	{
		MouseGetPos, Resizex2, Resizey2
		Resizexlength := % Resizex2 - Resizex1
		Resizeyheight := % Resizey2 - Resizey1
		winmove,LeftLimit,,%Resizex1%,%Resizey1%, 3, %Resizeyheight%,
		winmove,TopLimit,,%Resizex1%,%Resizey1%, %Resizexlength%, 3,
		winmove,RightLimit,,%Resizex2%,%Resizey1%, 3 ,%Resizeyheight%,
		winmove,DownLimit,,%Resizex1%, %Resizey2%, %Resizexlength%, 3,

		LButtonIsDown := GetKeyState("LButton", "P")
		
		If(LButtonIsDown = 0)
		{
			Break
			cornerval = 3
		}
	sleep, 20
	}
	;Re-work the corner variables of the actual limits used in the BIG if statements in the LButton hotkey - not just the green outlines
	Cornerx1 = %Resizex1%
	Cornery1 = %Resizey1%
	Cornerx2 = %Resizex2%
	Cornery2 = %Resizey2%
	return
}


WheelDown::
{
	if(ScrolldownEnable = 1)
	{
		send, {wheeldown}
		sleep, 100
	}
	Else
		++ScrollWheelErrorLog
Return 
}
WheelUp::
{
	if(ScrollupEnable = 1)
	{
		send, {wheelup}
		sleep, 100
	}
	Else
		++ScrollWheelErrorLog
Return
}

;ctrl & Rbutton::Rbutton
esc::
{
Gosub, ErrorLog
Clipboard = EXITMOUSETRAINER
reload
return
}
;Quitit:
ErrorLog:
{
	TotalErrors := % LButtonErrorLog + MButtonErrorLog + RButtonErrorLog + ScrollWheelErrorLog
	msgbox,,Assessment Log, LButton Errors = %LButtonErrorLog%`nMButton Errors = %MButtonErrorLog%`nRButton Errors = %RButtonErrorLog%`nScroll Wheel Errors = %ScrollWheelErrorLog%`nTotalErrors = %TotalErrors%,4
	LButtonErrorLog = 0
	MButtonErrorLog = 0
	RButtonErrorLog = 0
	ScrollWheelErrorLog = 0
	return
}

GuiClose:
{
Clipboard = EXITMOUSETRAINER
DllCall("SystemParametersInfo", UInt, 0x71, UInt, 0, UInt, Mouse_speed_orig, UInt, 0) ;Writes the original mousespeed
ExitApp
return
}


;Onexit, quitit